HDU 5937 Equation(DFS+剪枝)

题目链接 Equation

给定1-9这9个数字各自的卡片数,求能构成形如$i + j = k$的等式个数

等式中$i,j,k$必须都为个位数

若两个等式中$i,j,k$不完全相等,则这两个等式为不同的等式。

打表发现符合题意的等式有36个

那么通过01搜索状态数为$2^{36}$

TLE

我们求出若答案为36,每张卡片需求量$f[i]$

每次读入$a[i]$的时候

若对$i(1 <= i <= 9)$, 都有$a[i] >= f[i]$

则直接输出36

DFS的时候x为当前的等式用/不用

cnt为$1$到$x - 1$中用的等式个数

ans为当前保存答案的最大值

则当$cnt + 36 - x + 1 <= ans$的时候,剪枝

#include <bits/stdc++.h>

using namespace std;

#define rep(i, a, b)	for (int i(a); i <= (b); ++i)
#define dec(i, a, b)	for (int i(a); i >= (b); --i)

typedef long long LL;

struct node{
	int x, y, z;
} c[105];
int et = 0;
int f[11];
int a[11];
int ans;
int T;
int ca = 0;
vector <int> v;

void dfs(int x, int cnt){
	if (cnt + et - x + 1 <= ans) return;
	if (x > et){
		ans = max(ans, cnt);
		return;
	}

	dfs(x + 1, cnt);

	--a[c[x].x];
	--a[c[x].y];
	--a[c[x].z];

	if (a[c[x].x] >= 0 && a[c[x].y] >= 0 && a[c[x].z] >= 0){
		dfs(x + 1, cnt + 1);
		++a[c[x].x];
		++a[c[x].y];
		++a[c[x].z];
	}

	else{
		++a[c[x].x];
		++a[c[x].y];
		++a[c[x].z];
	}

}

int main(){

	rep(i, 1, 9) rep(j, 1, 9) rep(k, 1, 9){
		if (i + j == k){
			++et;
			c[et].x = i;
			c[et].y = j;
			c[et].z = k;
			++f[i], ++f[j], ++f[k];
		}
	}

	scanf("%d", &T);
	while (T--){
		printf("Case #%d: ", ++ca);
		rep(i, 1, 9) scanf("%d", a + i);
		bool fl = true;
		rep(i, 1, 9) if (a[i] < f[i]){
			fl = false;
			break;
		}

		if (fl){
			printf("%d\n", et);
			continue;
		}

		ans = 0;
		dfs(1, 0);
		printf("%d\n", ans);
	}

	return 0;
}
时间: 2024-12-08 19:16:17

HDU 5937 Equation(DFS+剪枝)的相关文章

HDU 5937 Equation

题意: 有1~9数字各有a1, a2, -, a9个, 有无穷多的+和=. 问只用这些数字, 最多能组成多少个不同的等式x+y=z, 其中x,y,z∈[1,9]. 等式中只要有一个数字不一样 就是不一样的 思路: 计算下可以发现, 等式最多只有36个. 然后每个数字i的上界是17-i个 可以预先判掉答案一定是36的, 然后直接暴力搜索每个等式要不要就好了. 注意剪枝即可 1 const int maxn = 20; 2 int a[maxn]; 3 bool flag36; 4 int ans;

hdu - 1072(dfs剪枝)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1072 思路:深搜每一个节点,并且进行剪枝,记录每一步上一次的s1,s2:如果之前走过的时间小于这一次, 就说明有更短的:路径,所以就不用继续遍历下去. #include<iostream> #include<cstdio> #include<cstring> using namespace std; int a[20][20],step[20][20],tim[20][20

hdu 1044(bfs+dfs+剪枝)

Collect More Jewels Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 6739    Accepted Submission(s): 1564 Problem Description It is written in the Book of The Lady: After the Creation, the cruel

hdu 4109 dfs+剪枝优化

求最久时间即在无环有向图里求最远路径 dfs+剪枝优化 从0节点(自己增加的)出发,0到1~n个节点之间的距离为1,mt[i]表示从0点到第i个节点目前所得的最长路径 #include<iostream> #include<cstdio> #include<cstring> #include<string> #include<algorithm> #include<vector> using namespace std; const

HDU 1010 Tempter of the Bone dfs+剪枝

给你一个迷宫一个起点和一个终点,问你能否走T步刚好到达终点,不能重复走,并且只有4个方向 显然这是一个dfs,虽然N最大只有7,但是裸的dfs复杂度还是太高了,因此要进行一些剪枝 1.如果T比图上所有的可走点还要大,肯定是不可行的.这个可以避免dfs整张图. 2.奇偶剪枝,有性质当前点(x,y)到目标点(tx,ty)的所有路径的长度的奇偶性一定和|x-tx|+|y-ty|一样. #include <cstdio> #include <iostream> #include <c

hdu 1010 Tempter of the Bone (DFS+剪枝)

Tempter of the Bone Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 68206    Accepted Submission(s): 18719 Problem Description The doggie found a bone in an ancient maze, which fascinated him a

ZOJ 1008 Gnome Tetravex (DFS + 剪枝)

Gnome Tetravex 题目:http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemId=8 题意:有N*N个方格,每个方格分为上下左右四个部分,每个部分填数字.现在要求重排方块,使得每两个有边相连的方块对应的数字相同. 思路:就是一个简单的搜索,我想了个剪枝,将上下左右四个方向上每个数字对应的是哪几个方块记录下来,但是这个剪枝并没有起很大的作用,还是T了.后来才发现,如果有很多个方块是相同的,会重复搜索,所以需要将相同的方块一起处

UVA 10318 - Security Panel dfs 剪枝

UVA 10318 - Security Panel dfs 剪枝 ACM 题目地址:UVA 10318 - Security Panel 题意: 这题跟点灯的题目很像,点灯游戏选择一盏灯时会让它以及四周的灯改变状态. 但是我们有特殊的开开关技巧,它给出了改变状态的位置,而不是四周都改变. 问你从全部关着变成全部开着的最小开关步骤. 分析: 很明显,在一个位置上点两次或更多次是没有必要的,所以一个位置只有选择与不选择,用dfs即可,但如果暴力所有可能,复杂度是2^25,会超时,所以要剪枝. 由于

Cubes(DFS+剪枝)

题意:给一个数N,求N最少由多少个数的立方构成,并输出这些数. 做法:DFS + 剪枝,剪枝的边界很很很重要! 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 #include <stdio.h> int cub[400]; int ans[300]; int tp[300]; int n; int sum = 0x3f3f3f3f; //个数 void dfs(int le